const std = @import("std");


pub fn main() !void {
    var gpa = std.heap.GeneralPurposeAllocator(.{}){};
    defer _ = gpa.deinit();
    const allocator = gpa.allocator();

    const username = std.os.getenv("USER");

    const path = try std.fmt.allocPrint(allocator, "/home/{s}/.config/lister/data.json", .{username});

    const file = try std.fs.cwd().openFile(path, .{});
    defer file.close();

    const data = try file.reader().readAllAlloc(allocator, 32768);
    defer allocator.free(data);

    const Smth = struct {
        name: []const u8,
        desc: []const u8,
    };

    const Smths = []Smth;

    const json = try std.json.parseFromSlice(Smths, allocator, data, .{});
    defer json.deinit();

    for (json.value) |smth| {
        std.debug.print("{s} -> {s}\n", .{smth.name, smth.desc});
    }
}
